<?php

function formatData($key, $value) {
	switch ($key) {
		case 'time':
			$mn = (($mn = floor($value / 60)) < 10) ? '0' . ($mn) : $mn;
			$sec = (($sec = floor($value % 60)) < 10) ? '0' . ($sec) : $sec;
			$value = $mn . ':' . $sec;
			break;

		default:
	}
	return $value;
}

function echoStat($key, $value) {
	if (is_array($value)) {
		$_tableData = $value;
		include dirname(__FILE__) . '/templates/statistics/table.phtml';
	}
	else {
		echo htmlText($value);
	}
}

function getLimit() {
	if (isset($_GET['l'])) {
		return ((int) $_GET['l']) || 'all' == $_GET['l'] ? $_GET['l'] : JMPDLOGGERWEB_PAGE_LIMIT_COUNT;
	}
	else {
		return JMPDLOGGERWEB_PAGE_LIMIT_COUNT;
	}
}

function getOffset() {
	if (isset($_GET['o'])) {
		return ((int) $_GET['o']) ? (int) $_GET['o'] : JMPDLOGGERWEB_PAGE_LIMIT_OFFSET;
	}
	else {
		return JMPDLOGGERWEB_PAGE_LIMIT_OFFSET;
	}
}

function getGoToPageUrl($page) {
	global $_statistics;

	$totalTracks = (int) $_statistics['Total Tracks Count'];
	$limit = getLimit();
	$offset = getOffset();
	switch($page)  {
		case 'previous':
			if ($offset - $limit < 0) {
				$url = "?l=$limit&o=0";
			}
			else {
				$url = "?l=$limit&o=" . ($offset - $limit);
			}
			break;
		case 'next':
			$url = "?l=$limit&o=" . ($offset + $limit);
			break;
		case 'first':
			$url = "?l=$limit&o=0";
			break;
		case 'last':
			$url = "?l=$limit&o=" . ($totalTracks - $totalTracks % $limit);
			break;

		default:
			$url = '#';
	}
	return htmlentities($url);
}

function getControlUrl($action) {
	$url = '?c=';

	switch($action)  {
		case 'previous':
			$url .= 'prev';
			break;
		case 'stop':
			$url .= 'stop';
			break;
		case 'play':
			$url .= 'play';
			break;
		case 'next':
			$url .= 'next';
			break;

		default:
			$url = '#';
	}
	return htmlentities($url);
}

function getCurrentTrackDetails() {
	global $pdo;

	$stmt = $pdo->prepare('select * from ' . JMPDLOGGERWEB_DB_MAINTABLE . ' order by ID desc limit 1');
	$stmt->execute();
	$lastTrackDetails = $stmt->fetchAll(PDO::FETCH_ASSOC);
	if (isset($lastTrackDetails[0])) {
		$lastTrackDetails = $lastTrackDetails[0];

		$playDateStart = strtotime($lastTrackDetails['date']);
		$playDateEnd = $playDateStart + $lastTrackDetails['time'];

		if (time() > ($playDateEnd + 15)) { 	// 15 seconds margin
			$lastTrackDetails = false;
		}
		else {
			foreach($lastTrackDetails as $key => &$value) {
				if (null === $value) {
					$value = '';
				}
			}
		}
	}
	else {
		$lastTrackDetails = false;
	}

	return $lastTrackDetails;
}

function getPageExecTime() {
	global $TIME_START;
	return number_format(microtime(true) - $TIME_START, 4);
}

function htmlText($text, $underscoresToSpaces = false) {
    $text = htmlspecialchars($text, ENT_COMPAT, 'UTF-8');
	return $underscoresToSpaces ? str_replace('_', ' ', $text) : $text;
}

//DEBUGGING & PROFILING
$__profileData = array();
function __profileStart($name, $desc = '') {
    global $__profileData;
    $__profileData[$name] = array(
    	'startTime' => microtime(true),
        'desc'      => $desc
    );
}
function __profileStop($name) {
    global $__profileData;
    if (!isset($__profileData[$name])) {
        return;
    }
    $__profileData[$name]['stopTime'] = microtime(true);
    $__profileData[$name]['totalTime'] = round(($__profileData[$name]['stopTime'] - $__profileData[$name]['startTime']) * 1000, 4) . ' ms';
}
function __profileDump() {
    global $__profileData;
    echo "<pre>==PROFILE DATA==\n";
    print_r($__profileData);
    echo "</pre>";
}