<?php
/**
 * JMPDLoggerWeb
 * A Web Viewer for JMPDLogger
 *
 * @author Anael Ollier <nanawel@gmail.com>
 * @since 2011-04-08
 * @version 0.5.0
 * @license See LICENSE.txt
 */

/*
 * Initialization...
 */
$TIME_START = microtime(true);

ini_set('error_reporting', E_ALL);
ini_set('display_error', 1);

include dirname(__FILE__) . '/config.inc.php';
include dirname(__FILE__) . '/functions.inc.php';
include dirname(__FILE__) . '/handleControls.inc.php';
$pdo = new PDO(JMPDLOGGERWEB_DB_CONNECTIONSTRING, JMPDLOGGERWEB_DB_USER, JMPDLOGGERWEB_DB_PASSWORD);


/*
 * == Tracks Table ==
 */
$limit = getLimit();
$offset = getOffset();
$query = 'select * from ' . JMPDLOGGERWEB_DB_MAINTABLE . ' order by ID desc' . ' limit ' . $limit . ' offset ' . $offset;
$stmt = $pdo->prepare($query);
__profileStart('HISTORY SELECT', $query);
$stmt->execute();
$_tracks = $stmt->fetchAll(PDO::FETCH_ASSOC);
__profileStop('HISTORY SELECT');

/*
 * == Statistics ==
 */
$_statistics = array();

$query = 'select count(id) from ' . JMPDLOGGERWEB_DB_MAINTABLE;
$stmt = $pdo->prepare($query);
__profileStart('HISTORY COUNT RECORDS', $query);
$stmt->execute();
$_statistics['Total Tracks Count'] = $stmt->fetchColumn(0);
__profileStop('HISTORY COUNT RECORDS');

$query ='select DATE from ' . JMPDLOGGERWEB_DB_MAINTABLE . ' order by DATE asc limit 1';
$stmt = $pdo->prepare($query);
__profileStart('OLDEST HISTORY RECORD', $query);
$stmt->execute();
$_statistics['Oldest History Record'] = $stmt->fetchColumn(0);
__profileStop('OLDEST HISTORY RECORD');

if (!JMPDLOGGERWEB_DISABLE_HEAVYWEIGHT_STATS) {
    $query = 'select ARTIST, count(ID) as PLAY_COUNT from ' . JMPDLOGGERWEB_DB_MAINTABLE . ' group by ARTIST order by PLAY_COUNT desc limit 10';
    $stmt = $pdo->prepare($query);
    __profileStart('MOST PLAYED ARTISTS', $query);
    $stmt->execute();
    $_statistics['Most Played Artists'] = $stmt->fetchAll(PDO::FETCH_ASSOC);
    __profileStop('MOST PLAYED ARTISTS');

    $query = 'select ALBUM, ARTIST, count(ID) as PLAY_COUNT '
           . 'from ' . JMPDLOGGERWEB_DB_MAINTABLE . ' as MAIN_TABLE group by ALBUM, ARTIST order by PLAY_COUNT desc limit 10';
    $stmt = $pdo->prepare($query);
    __profileStart('MOST PLAYED ALBUMS', $query);
    $stmt->execute();
    $_statistics['Most Played Albums'] = $stmt->fetchAll(PDO::FETCH_ASSOC);
    __profileStop('MOST PLAYED ALBUMS');
}

header('Cache-Control: no-cache, must-revalidate');
header('Content-Type" content="text/html;charset=UTF-8');
include dirname(__FILE__) . '/templates/page.phtml';

//__profileDump();